jQuery(document).ready(function ($) {

	var urlReg = '/reg.aspx';

	var currentStep = 0; // Current Step
	var nextBtn = $('.next_step'); // Next Button

	var errorTrls = {
		errEmail1: 'Please enter a valid email address.',
		errEmail2: 'Email is not valid.',
		errZip1: 'Invalid zip code. Must have 5 digits',
		errUsername1: 'Choose a username',
		errUsername2: 'Username must contain at least 3 characters.',
		errUsername3: 'Username must start with a letter and only allows a-z & 0-9.',
		errUsername4: 'The name can contain no more than 4 numbers',
		errPassword1: 'Password must contain letters and numbers and be 6-16 characters.',
		errPassword2: 'Please enter a password.',
		errAge1: 'Invalid age. You must be 18+.'
	};

	var fieldTexts = {
		emailText: $('.email_p .sub').text(),
		usernameText: $('.name_p .sub').text(),
		passwordText: $('.pwd_p .sub').text(),
		ageText: $('.p_bday .sub').text()
	};

	if (!!translation) {
		if (translation[language].errEmail1) errorTrls.errEmail1 = translation[language].errEmail1;
		if (translation[language].errEmail2) errorTrls.errEmail2 = translation[language].errEmail2;
		if (translation[language].errZip1) errorTrls.errZip1 = translation[language].errZip1;
		if (translation[language].errUsername1) errorTrls.errUsername1 = translation[language].errUsername1;
		if (translation[language].errUsername2) errorTrls.errUsername2 = translation[language].errUsername2;
		if (translation[language].errUsername3) errorTrls.errUsername3 = translation[language].errUsername3;
		if (translation[language].errUsername4) errorTrls.errUsername4 = translation[language].errUsername4;
		if (translation[language].errPassword1) errorTrls.errPassword1 = translation[language].errPassword1;
		if (translation[language].errPassword2) errorTrls.errPassword2 = translation[language].errPassword2;
		if (translation[language].errAge1) errorTrls.errAge1 = translation[language].errAge1;
	}

	function checkLength(o, n, min, max) {
		if (o.length > max || o.length < min) {
			return n
		} else return '';
	}

	function checkNumber(o, n, min) {
		if (o < min || !$.isNumeric(o)) {
			return n;
		} else return '';
	}

	function checkRegexp(o, regexp, n) {
		if (!( regexp.test(o) )) {
			return n
		} else return '';
	}

	function validateEmail(email) {
		var re = /^(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])$/i;
		return re.test(email);
	}

	function validatePass(o, n) {
		var letter = /[a-zA-Z]/;
		var number = /[0-9]/;
		var valid = number.test(o) && letter.test(o) && o.length >= 6 && o.length <= 16;
		if (valid) {
			return '';
		} else return n;
	}

	function getParameterByName(name) {
		name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
		var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
			results = regex.exec(location.search);
		return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
	}

	function getAgeByBirth(d, m, y) {
		var today_date = new Date();
		var today_year = today_date.getFullYear();
		var today_month = today_date.getMonth();
		var today_day = today_date.getDate();
		var age = today_year - y;

		if (today_month < (m - 1)) {
			age--;
		}
		if (((m - 1) == today_month) && (today_day < d)) {
			age--;
		}
		return age;
	}

	function checkDigits(o, n) {
		var resp = o.match(/\d/g);
		if (!resp) return ''; // console.log(resp);
		var len = resp.length; // console.log(len);
		if (len && (len > 4)) {
			return n;
		} else return '';
	}
	function runAfterSent(data){
		if (data == "sent" || data == "msg") {
			$('#success-mail').text($('.email_p .input').val());

			$('#Fr1>p,#as_back,#as_next,#as_agree,#free_step_01,#free_step_03,#free_step_05,.bullets,.item1').hide();
			$('#success-message').show();
		} else {
			setTimeout(function(){
	            document.location.href = data; // url from server
	        }, 200);
		}
	}
	function handleSending() {

		var c = getParameterByName('c') ? getParameterByName('c') : '';
		var aid = getParameterByName('a') ? getParameterByName('a') : '';

		var formData = {
			'a' : $('.birthday.day').val(),
			'e' : $('.email_p .input').val(),
			'z' : 0,
			'p' : $('.pwd_p .input').val(),
			'c' : c,
			'aid' : aid,
			'l' : 0
		};
		//console.log("formData", formData);

		nextBtn.addClass('disabled');

		$.ajax({
			type: 'POST',
			url: urlReg,
			data: formData
		}).success(function(data) {
			runAfterSent(data);
		}).error( function (jqXHR, status, error) {
			nextBtn.removeClass('disabled');
			console.log(jqXHR.responseText);
		});

	}

	function show_next(n) {
		currentStep += n;

		$('.nav_button').removeClass('nav_active');
		$('.nav' + currentStep).addClass('nav_active').prevAll().addClass('nav_active');

		$('#Fr1>p,#as_back,#as_next,#as_agree,#free_step_01,#free_step_03,#free_step_05,.bullets,#success-message').hide();

		if (currentStep === 0) {
			$('#free_step_01,#as_agree').show();
		}
		else if (currentStep === 1) {
			$('.p_bday,#as_next,#as_back,.bullets').show();
		}
		else if (currentStep === 2) {
			$('#free_step_03,#as_next,#as_back,.bullets').show();
		}
		else if (currentStep === 3) {
			$('.pwd_p,#as_next,#as_back,.bullets').show();
			$('.pwd_p input').focus();
		}
		else if (currentStep === 4) {
			$('#free_step_05,#as_next,#as_back,.bullets').show();
		}
		else if (currentStep === 5) {
			$('.email_p,#as_next,#as_back,.bullets').show();
			$('.email_p input').focus();
		}
	}

	show_next(0);

	$('.back_step').on('click', function (e) {
		e.preventDefault();
		if (currentStep === 0) return;
		show_next(-1);
	});

	nextBtn.on('click', function (e) {
		e.preventDefault();
		var err = 0;

		$('.err').removeClass('err');

		if (currentStep === 1) {

			var age = $('.birthday').val();
			var birthdayErrorInfo = $('.p_bday .sub');

			if (age < 18 || age > 99) {
				err = errorTrls.errAge1;
			}

			if (err) {
				birthdayErrorInfo.text(err);
				$('.birthday').addClass('err');
			} else {
				birthdayErrorInfo.text(fieldTexts.ageText);
			}

		}
		else if (currentStep === 3) {

			var passwordInput = $('.pwd_p .input');
			var password = passwordInput.val();
			var passwordErrorInfo = $('.pwd_p .sub');

			if (!password.length) {
				err = errorTrls.errPassword2;
			} else {
				err = validatePass(password, errorTrls.errPassword1);
			}

			if (err) {
				passwordErrorInfo.text(err);
				passwordInput.addClass('err');
			} else {
				passwordErrorInfo.text(fieldTexts.passwordText);
			}

		}
		else if (currentStep === 5) {

			var emailInput = $('.email_p .input');
			var email = emailInput.val();
			var emailErrorInfo = $('.email_p .sub');

			if (!email.length) {
				err = errorTrls.errEmail1;
			} else if (!validateEmail(email)) {
				err = errorTrls.errEmail2;
			}

			if (err) {
				emailErrorInfo.text(err);
				emailInput.addClass('err');
			} else {
				emailErrorInfo.text(fieldTexts.emailText);

				handleSending();
			}

			return;
		}

		if (!err) show_next(1); else show_next(0);
	});

	// Timer
	function startTimer(duration, display) {
		var timer = duration, minutes, seconds;
		setInterval(function () {
			minutes = parseInt(timer / 60, 10);
			seconds = parseInt(timer % 60, 10);

			minutes = minutes < 10 ? "0" + minutes : minutes;
			seconds = seconds < 10 ? "0" + seconds : seconds;

			display.text(minutes + ":" + seconds);

			if (--timer < 0) {
				timer = duration;
			}
		}, 1000);
	}

	jQuery(function ($) {
		var fiveMinutes = 60 * 30,
			display = $('#time');
		startTimer(fiveMinutes, display);
	});

	// Image Highlight on Click
	$.each([1,2,3,4,5,6], function() {
		var index = this;

		$('#pick_kind_0' + index).click(function () {
			$('#pick_kind_0' + index + ' img').toggleClass('img_active');
		});

		$('#pick_looking_0' + index).click(function () {
			$(this).toggleClass('img_active_02');
		});
	});

	// Enter Key
	$('#Fr1 .input').keypress(function (e) {
		if (e.which == 13) {
			e.preventDefault();
			nextBtn.click();
		}
	});

});


